From 24a47b19e6a43100b330d2a85a1f647037030175 Mon Sep 17 00:00:00 2001
From: Nils Philippsen <nils@redhat.com>
Date: Jan 18 2018 16:36:31 +0000
Subject: [PATCH 22/48] components: cope with native objects in setters


---

diff --git a/modulemd/components/__init__.py b/modulemd/components/__init__.py
index b7ef95a..005f3c8 100644
--- a/modulemd/components/__init__.py
+++ b/modulemd/components/__init__.py
@@ -108,8 +108,13 @@ class ModuleComponents(object):
         if not isinstance(d, dict):
             raise TypeError("components.rpms: data type not supported")
         for k, v in d.items():
-            if not isinstance(k, str) or not isinstance(v, ModuleComponentRPM):
-                raise TypeError("components.rpms: data type not supported")
+            if not (isinstance(k, str)
+                    and isinstance(v, (ModuleComponentRPM,
+                                       Modulemd.ComponentRpm))):
+                raise TypeError("components.rpms: data type not supported"
+                                " ({!r}: {!r})".format(k, v))
+            if isinstance(v, Modulemd.ComponentRpm):
+                d[k] = ModuleComponentRPM._new_from_native(k, v)
         self._rpms = d
 
         self._save_to_libmodulemd()
@@ -155,8 +160,13 @@ class ModuleComponents(object):
         if not isinstance(d, dict):
             raise TypeError("components.modules: data type not supported")
         for k, v in d.items():
-            if not isinstance(k, str) or not isinstance(v, ModuleComponentModule):
-                raise TypeError("components.modules: data type not supported")
+            if not (isinstance(k, str)
+                    and isinstance(v, (ModuleComponentModule,
+                                       Modulemd.ComponentModule))):
+                raise TypeError("components.modules: data type not supported"
+                                " ({!r}: {!r})".format(k, v))
+            if isinstance(v, Modulemd.ComponentModule):
+                d[k] = ModuleComponentModule._new_from_native(k, v)
         self._modules = d
 
         self._save_to_libmodulemd()
diff --git a/modulemd/components/module.py b/modulemd/components/module.py
index 9a0d2c2..509d2dd 100644
--- a/modulemd/components/module.py
+++ b/modulemd/components/module.py
@@ -35,6 +35,13 @@ class ModuleComponentModule(ModuleComponentBase):
         self.repository = repository
         self.ref = ref
 
+    @classmethod
+    def _new_from_native(cls, name, native_comp):
+        return cls(name, native_comp.get_rationale(),
+                   buildorder=native_comp.get_buildorder() or 0,
+                   repository=native_comp.get_repository() or "",
+                   ref=native_comp.get_ref() or "")
+
     def __repr__(self):
         return ("<ModuleComponentModule: "
                 "name: {0}, "
diff --git a/modulemd/components/rpm.py b/modulemd/components/rpm.py
index 3d24430..b703af2 100644
--- a/modulemd/components/rpm.py
+++ b/modulemd/components/rpm.py
@@ -38,6 +38,16 @@ class ModuleComponentRPM(ModuleComponentBase):
         self.arches = arches
         self.multilib = multilib
 
+    @classmethod
+    def _new_from_native(cls, name, native_comp):
+        return cls(name, native_comp.get_rationale(),
+                   buildorder=native_comp.get_buildorder() or 0,
+                   repository=native_comp.get_repository() or "",
+                   ref=native_comp.get_ref() or "",
+                   cache=native_comp.get_cache() or "",
+                   arches=set(native_comp.get_arches().get()),
+                   multilib=set(native_comp.get_multilib().get()))
+
     def __repr__(self):
         return ("<ModuleComponentRPM: "
                 "name: {0}, "

